; ==============================================================================
;	Graphic
; ------------------------------------------------------------------------------
;	Date		Author	Ver		Description
;	2020/9/22	t.hara	1.0		1st release
; ==============================================================================

vdp_port0	:=	0x98
vdp_port1	:=	0x99

; ==============================================================================
;	grp_init
;	ʂ
; ==============================================================================
		scope	grp_init
grp_init::
		; SCREEN 2
		ld		a, [scrmod]
		ld		[oldscr], a

		ld		a, 2
		ld		ix, CHGMOD
		ld		iy, [exptbl - 1]
		call	CALSLT

		; MSX2ȏȂpbg
		ld		hl, 0x002D
		ld		a, [exptbl]
		call	RDSLT
		or		a, a
		call	nz, palette_init

		; XvCg2{p[h, 16x16[h
		ld		a, [rg1sav]
		or		a, 3
		ld		c, 1
		ld		b, a
		ld		ix, WRTVDP
		call	CALSLT

		; VDP R#7 = 0x00  (wi)
		ld		c, 7
		ld		b, 0
		ld		ix, WRTVDP
		call	CALSLT

		; Color Table  0xF0 œhԂ
		ld		hl, 0x2000
		ld		bc, 256 * 8 * 3
		ld		a, 0xF0
		ld		ix, FILVRM
		call	CALSLT

		; XvCgWFl[^e[u 0x00 œhԂ
		ld		hl, 0x3800
		ld		bc, 256 * 8
		xor		a, a
		ld		ix, FILVRM
		call	CALSLT

		; l[e[üꕔXV
		ld		a, 85
		ld		bc, (8 << 8) | vdp_port0
		ld		hl, 0x1800
init_name_table_left:
		push	af
		ld		ix, SETWRT
		call	CALSLT
		pop		af

		push	bc
		ld		b, 15
init_name_table_left_line:
		out		[c], a
		inc		a
		djnz	init_name_table_left_line
		ld		bc, 32
		add		hl, bc
		pop		bc
		djnz	init_name_table_left

		ld		hl, 0x1800 + 15
		ld		de, 32
		call	init_name_table_right_other_line
		xor		a, a						; ޒl̏l
		ld		b, 4
init_name_table_right_bar:
		push	af
		ld		ix, SETWRT
		call	CALSLT						; VRAMAhXݒ
		pop		af
		add		hl, de						; HL͉̃AhX֑JڂĂ
		push	bc
		ld		b, 17						;  0, 4, 8, 12 ... 64 
init_name_table_right_bar_line:
		out		[c], a
		add		a, 4
		djnz	init_name_table_right_bar_line
		pop		bc
		sub		a, 67						; 68  1
		djnz	init_name_table_right_bar

		ld		a, 68
		call	init_name_table_right_other_line
		ld		a, 222
		call	init_name_table_right_other_line
		call	init_name_table_right_other_line

		; MGSPS`悷
		ld		hl, 0x0000 + 85 * 8
		ld		de, mgsp_logo_pattern
		ld		b, 4 * 8
		call	memcpy_m2v

		ld		b, 30
		ld		hl, 0x2000 + 85 * 8
logo_color_loop:
		push	bc
		push	hl
		ld		de, mgsp_logo_color
		ld		b, 8
		call	memcpy_m2v
		pop		hl
		ld		de, 8
		add		hl, de
		pop		bc
		djnz	logo_color_loop

		; t@NVL[`悷
		ld		hl, 0x0000 + (256 + 256 + 224) * 8
		ld		de, mgsp_function_key_pattern1
		ld		b, (3 * 5) * 8
		call	memcpy_m2v

		ld		hl, 0x0000 + (256 + 256 + 241) * 8
		ld		de, mgsp_function_key_pattern2
		ld		b, (3 * 5) * 8
		call	memcpy_m2v

		ld		b, 32
		ld		hl, 0x2000 + (256 + 256 + 224) * 8
function_color_loop:
		push	bc
		push	hl
		ld		de, mgsp_function_key_color
		ld		b, 8
		call	memcpy_m2v
		pop		hl
		ld		de, 8
		add		hl, de
		pop		bc
		djnz	function_color_loop

		; o[W\
		ld		hl, 89 * 8
		ld		de, mgsp_version
		call	draw_string
		; Copyright
		ld		hl, 100 * 8
		ld		de, mgsp_copyright
		call	draw_string
		; Order
		ld		hl, 175 * 8
		ld		de, mgsp_order
		call	draw_string
		; Volume
		ld		hl, 190 * 8
		ld		de, mgsp_volume
		call	draw_string
		; ch
		ld		hl, 222 * 8
		ld		de, mgsp_ch
		call	draw_string
		; Auto mode
		ld		hl, 197 * 8
		ld		de, mgsp_automode
		call	draw_string
		; Loop count
		ld		hl, 239 * 8
		ld		de, mgsp_loop_count
		call	draw_string
		; Filename
		ld		hl, 246 * 8
		ld		de, mgsp_filename
		call	draw_string

		; Sound source logo
		ld		hl, 218 * 8
		ld		de, mgsp_sound_source_logo
		ld		b, 4 * 8
		call	memcpy_m2v

		call	change_mgsdrv_slot
		ld		hl, [mgs_id_mibadr]
		ld		a, [hl]
		inc		a
		ld		de, mgsp_sound_source_logo_not_found_color
		jr		z, opll_is_not_found
		ld		de, mgsp_sound_source_logo_found_color
opll_is_not_found::
		ld		hl, 0x2000 + 221 * 8
		ld		b, 8
		call	memcpy_m2v

		ld		hl, [mgs_id_mibadr]
		inc		hl
		ld		a, [hl]
		inc		a
		ld		de, mgsp_sound_source_logo_not_found_color
		jr		z, scc_is_not_found
		ld		de, mgsp_sound_source_logo_found_color
scc_is_not_found::
		ld		hl, 0x2000 + 218 * 8
		ld		b, 8
		push	de
		call	memcpy_m2v
		pop		de
		ld		hl, 0x2000 + 219 * 8
		ld		b, 8
		push	de
		call	memcpy_m2v
		pop		de
		ld		hl, 0x2000 + 220 * 8
		ld		b, 8
		push	de
		call	memcpy_m2v
		pop		de

		; Ղ`悷
		ld		de, mgsp_keyboard_pattern1
		ld		hl, 0x0000 + 115 * 8
		call	draw_keyboard

		ld		de, mgsp_keyboard_pattern2
		ld		hl, 0x0000 + 130 * 8
		call	draw_keyboard

		ld		de, mgsp_keyboard_pattern1
		ld		hl, 0x0000 + 145 * 8
		call	draw_keyboard

		ld		de, mgsp_keyboard_pattern2
		ld		hl, 0x0000 + 160 * 8
		call	draw_keyboard

		ld		b, 15
		ld		hl, 0x2000 + 130 * 8
key_color_loop1:
		push	bc
		push	hl
		ld		de, mgsp_keyboard_color
		ld		b, 8
		call	memcpy_m2v
		pop		hl
		ld		de, 8
		add		hl, de
		pop		bc
		djnz	key_color_loop1

		ld		b, 15
		ld		hl, 0x2000 + 160 * 8
key_color_loop2:
		push	bc
		push	hl
		ld		de, mgsp_keyboard_color
		ld		b, 8
		call	memcpy_m2v
		pop		hl
		ld		de, 8
		add		hl, de
		pop		bc
		djnz	key_color_loop2

		; Ղ̋P_pXvCgzu
		ld		hl, 0x1B00
		ld		de, mgsp_keyboard_spot_attrib
		ld		b, 4 * 4 * 4
		call	memcpy_m2v

		; `悷
		ld		hl, (256 + 0) * 8
		ld		b, 0					; 256̈Ӗ
		ld		d, 0xFF
		call	memset_v

		ld		hl, (256 + 64) * 8
		ld		b, 31 * 8
		ld		d, 0xFF
		call	memset_v

		ld		hl, (256 + 256 + 192) * 8
		ld		b, 31 * 8
		ld		d, 0xFF
		call	memset_v

		ld		hl, 0x2000 + (256 + 0) * 8
		ld		b, 0					; 256̈Ӗ
		ld		d, 0x47
		call	memset_v

		ld		hl, 0x2000 + (256 + 64) * 8
		ld		b, 0					; 256̈Ӗ
		ld		d, 0x47
		call	memset_v

		ld		hl, 0x2000 + (256 + 256 + 192) * 8
		ld		b, 0					; 256̈Ӗ
		ld		d, 0x47
		call	memset_v

		; XN[o[
		ld		hl, (256 + 95) * 8
		ld		de, mgsp_scroll_bar_up_pattern
		ld		b, 8
		call	memcpy_m2v

		; XN[o[
		ld		hl, (256 + 256 + 223) * 8
		ld		de, mgsp_scroll_bar_down_pattern
		ld		b, 8
		call	memcpy_m2v

		; ʃo[̏[ɐFt
		ld		b, 17
		ld		hl, 0x2000
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT

volume_bar_color_loop1:
		push	bc
		ld		hl, mgsp_volume_bar_color
		ld		bc, (8 << 8) | vdp_port0
volume_bar_color_loop2:
		ld		a, [hl]
		out		[c], a
		bit		0, [hl]		; VDP wait
		out		[c], a
		bit		0, [hl]		; VDP wait
		out		[c], a
		bit		0, [hl]		; VDP wait
		out		[c], a
		inc		hl
		djnz	volume_bar_color_loop2
		pop		bc
		djnz	volume_bar_color_loop1

		; CH. ON/OFF XCb``悷
		ld		hl, 68 * 8
		ld		de, mgsp_track_sw_pattern
		ld		b, 8 * 3
		call	memcpy_m2v

		ld		hl, 0x2000 + 68 * 8
		ld		de, mgsp_track_sw_color
		ld		b, 8 * 3
		call	memcpy_m2v

		ld		hl, 0x1800 + (5 * 32 + 15)
		ld		d, 68
		ld		b, 17
		call	memset_v

		; Volume ̐F
		ld		hl, 0x2000 + 194 * 8
		ld		de, mgsp_volume_color
		ld		b, 8
		call	memcpy_m2v

		ld		hl, 0x2000 + 195 * 8
		ld		de, mgsp_volume_color
		ld		b, 8
		call	memcpy_m2v

		; t@C\GA PCGzuύX
		ld		hl, 0x1800 + (256 + 96)
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT

		ld		a, 96
		ld		bc, (5 << 8) | vdp_port0
		ld		d, 251
		call	file_name_area_pcg

		ld		a, 6
		ld		b, 6
		ld		d, 0
		call	file_name_area_pcg

		; XN[o[
		ld		hl, 0x2000 + (256 + 251) * 8
		ld		b, 11 * 8
		ld		d, 0x44
		call	memset_v

		ld		hl, 0x0000 + (256 + 251) * 8
		ld		b, 11 * 8
		ld		d, 0x81
		call	memset_v
		ret

		; ----------------------
draw_keyboard:
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT

		ex		de, hl
		push	hl
		ld		bc, ((8 * 7) << 8) | vdp_port0
draw_keyboard_loop1:
		outi
		jr		nz, draw_keyboard_loop1		; OTIRƑ
		pop		hl
		ld		b, 8 * 7
draw_keyboard_loop2:
		outi
		jr		nz, draw_keyboard_loop2		; OTIRƑ
		ret

palette_init:
		di
		ld		c, vdp_port1
		xor		a, a
		out		[c], a
		ld		a, 0x80 + 16
		out		[c], a
		inc		c
		ld		hl, palettes_like_msx1
		ld		b, 32
		otir								; V9938/V9958  OTIR łȂ
		ei

		; VDP R#9  bit1  0 ɂ (I NTSC ɂ)
		ld		a, [rg9sav]
		and		a, 0b1111_1101				; NT(bit1) = 0.  0:NTSC, 1:PAL
		ld		c, 9
		ld		b, 0
		ld		ix, WRTVDP
		ld		iy, [exptbl - 1]
		call	CALSLT
		ret

init_name_table_right_other_line:
		push	af
		ld		ix, SETWRT
		call	CALSLT						; VRAMAhXݒ
		pop		af
		add		hl, de						; HL͉̃AhX֑JڂĂ
		ld		b, 17						;  205, 206, ... , 221 
init_name_table_right_other_line_col:
		out		[c], a
		inc		a
		djnz	init_name_table_right_other_line_col
		ret

palettes_like_msx1:
		db		0x00, 0x00				; 0
		db		0x00, 0x00				; 1
		db		0x33, 0x05				; 2
		db		0x44, 0x06				; 3
		db		0x37, 0x02				; 4
		db		0x47, 0x03				; 5
		db		0x52, 0x03				; 6
		db		0x36, 0x05				; 7
		db		0x62, 0x03				; 8
		db		0x63, 0x04				; 9
		db		0x53, 0x06				; 10
		db		0x64, 0x06				; 11
		db		0x21, 0x04				; 12
		db		0x55, 0x03				; 13
		db		0x55, 0x05				; 14
		db		0x77, 0x07				; 15
		endscope

; ==============================================================================
;	VRAMւ̃ubN]
;	input)
;		hl ..... ]VRAMAhX
;		de ..... ]AhX
;		b  ..... ]oCg
; ==============================================================================
		scope	memcpy_m2v
memcpy_m2v::
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT

		ld		c, vdp_port0
loop:
		ld		a, [de]
		out		[c], a
		inc		de
		djnz	loop
		ret
		endscope

; ==============================================================================
;	VRAMw̒lœhԂ
;	input)
;		hl ..... ]VRAMAhX
;		d ...... hԂl
;		b ...... ]oCg
;	break)
;		af, bc
; ==============================================================================
		scope	memset_v
memset_v::
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT

		ld		c, vdp_port0
loop:
		nop
		out		[c], d
		djnz	loop
		ret
		endscope

; ==============================================================================
;	t@C\̈ PCGXV̈ꕔ
;	input)
;		a ...... ڃC̍[ PCGԍ
;		d ...... ڃC̉E[ PCGԍ
;		b ...... JԂC
;		c ...... VDP port#0
;	output)
;		--
;	break)
;		af, bc, de
;	comment)
;		a = 6, d = 0 ȂAڃC͉L̂悤ɂȂ
;		[ 6][ 7][ 8][ 9] .... [35][36][ 0]
;		E[ d ̒lɂȂB̃C͂̑ɂȂB
;		[37][38][39][40] .... [66][67][ 1]
;		E[̓XN[o[̕`ʒuŁAXN[o[ŘAԍɂ
;		̂ړIB
; ==============================================================================
		scope	file_name_area_pcg
file_name_area_pcg::
loop1:
		push	bc
		ld		b, 31
loop2:
		out		[c], a
		inc		a
		djnz	loop2

		out		[c], d
		inc		d
		pop		bc
		djnz	loop1
		ret
		endscope

; ==============================================================================
;	grp_term
;	ʂ̌n
; ==============================================================================
		scope	grp_term
grp_term::
		; ʂ̃tF[hAEg
		ld		de, 2267
		ld		hl, 0x2000 + 373 * 8 + 3
		ld		b, 128
loop1:
		push	bc
		ld		b, 48
loop2:
		push	bc
		; ڃAhX 0x00  (F = )
		push	de
		push	hl
		xor		a, a
		ld		ix, WRTVRM
		ld		iy, [exptbl - 1]
		call	CALSLT
		pop		hl
		pop		de
		; ̃AhXvZ
		add		hl, de
		ld		a, h
		cp		a, 0x38
		jr		c, skip1
		sub		a, 0x18
		ld		h, a
skip1:
		pop		bc
		djnz	loop2
		; 荞ݑ҂
		halt
		pop		bc
		djnz	loop1

		; 0.1b ҋ@
		halt
		halt
		halt
		halt
		halt
		halt

		; ʃ[h߂
		ld		a, [oldscr]
		ld		ix, CHGMOD
		ld		iy, [exptbl - 1]
		call	CALSLT

		; MSX2ȏȂpbg
		ld		hl, 0x002D
		ld		a, [exptbl]
		call	RDSLT
		or		a, a
		ret		z

		ld		ix, sub_iniplt
		ld		iy, [exbrsa - 1]
		jp		CALSLT
		endscope

; ==============================================================================
;	grp_update_scroll_bar
; ==============================================================================
		scope	grp_update_scroll_bar
grp_update_scroll_bar::
		ld		hl, 0x2000 + (256 + 251) * 8
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT

		ld		a, [fl_files]
		cp		a, 12
		jr		c, no_scroll

		ld		c, a
		ld		a, [grp_top_file]
		call	grp_calc_scroll_pos
		ld		[save_a], a
		or		a, a
		jr		z, skip1
		ld		b, a
		ld		c, vdp_port0
		ld		a, 0x44
loop2:
		out		[c], a
		nop
		djnz	loop2
skip1:
		ld		a, [fl_files]
		ld		c, a
		ld		a, 11
		call	grp_calc_scroll_pos
		ld		b, a
		ld		a, [save_a]
		add		a, b
		ld		[save_a], a
		ld		c, vdp_port0
		ld		a, 0x47
loop3:
		out		[c], a
		nop
		djnz	loop3

		ld		a, [save_a]
		ld		b, a
		ld		a, 88
		sub		a, b
		ret		c
		ret		z
		ld		b, a
		ld		c, vdp_port0
		ld		a, 0x44
loop4:
		out		[c], a
		nop
		djnz	loop4
		ret

		; XN[Ȃꍇ
no_scroll:
		ld		b, 11 * 8
		ld		c, vdp_port0
		ld		a, 0x40
loop1:
		out		[c], a
		nop
		djnz	loop1
		ret
save_a:
		db		0
		endscope

; ==============================================================================
;	a = a * 88 / c : a = 0`64, c = 0`64, K a <= c
;	break)
;	af, bc, de, hl
; ==============================================================================
		scope	grp_calc_scroll_pos
grp_calc_scroll_pos::
		; HL = a * 88 = a * 8 * (8 + 1 + 1 + 1)
		add		a, a
		ld		l, a
		ld		h, 0
		add		hl, hl
		add		hl, hl
		ld		d, h		; de = x8
		ld		e, l
		add		hl, hl
		add		hl, hl
		add		hl, hl
		add		hl, de
		add		hl, de
		add		hl, de
		; HL / C
		ld		b, 9
		ld		a, h
		ld		h, 0
loop1:
		sub		a, c
		jr		nc, skip1
		add		a, c
skip1:
		rl		h
		sla		l
		rl		a
		djnz	loop1
		ld		a, h
		cpl
		ret
		endscope

; ==============================================================================
;	grp_update_master_volume
;	}X^[{[\XV
;	input)
;		a ..... }X^[{[ (0ő, 15ŏ)
; ==============================================================================
		scope	grp_update_master_volume
grp_update_master_volume::
		add		a, a
		ld		l, a
		ld		h, 0
		ld		de, grp_volume_table
		add		hl, de
		ld		d, [hl]
		inc		hl
		ld		e, [hl]

		ld		hl, 194 * 8
		ld		b, 8
		call	memset_v

		ld		hl, 195 * 8
		ld		b, 8
		ld		d, e
		jp		memset_v
		endscope

; ==============================================================================
;	grp_update_file_list
;	t@Cꗗ\XV
;	input)
;		a ................... 0: ʏ, 1: StbV
;		[fl_files] .......... ꗗ\Ɋi[Ăt@C
;		[fl_select_file] .... I𒆂̃t@C̔ԍ (ꗗ\̒̉Ԗڂ)
; ==============================================================================
		scope	grp_update_file_list
grp_update_file_list::
		push	af
		; [IsI\ɂ
		call	grp_unselect_playing_line
		call	grp_unselect_line
		; t@C݂ꍇAꗗ̈ԏɕ\Ggԍ߂
		call	grp_get_top_entry_number
		push	af
		call	grp_playing_line
		pop		af
		ld		b, a

		pop		af
		or		a, a
		jr		nz, do_update			; fource update

		ld		a, b
		or		a, a
		jp		z, clear_space
		dec		a
		jp		z, grp_select_line

do_update:
		ld		a, [grp_top_file]
		ld		b, 0
		ld		c, a
loop:
		push	bc
		ld		a, c
		call	get_current_file_entry
		push	hl
		; grp_draw_file_line  ' 'ŃtB
		ld		hl, grp_draw_file_line
		ld		de, grp_draw_file_line + 1
		ld		bc, 62
		ld		a, ' '
		ld		[hl], a
		ldir
		xor		a, a
		ld		[de], a
		pop		ix
		; fBNgH MGSt@CH
		ld		a, [ix + FENT_MGS_TITLE_ADDRESS]
		or		a, [ix + FENT_MGS_TITLE_ADDRESS + 1]
		jp		z, draw_directory
		; MGSt@C̏ꍇ
draw_mgs_file:
		; -- Ȗobt@փRs[
		ld		l, [ix + FENT_MGS_TITLE_ADDRESS]
		ld		h, [ix + FENT_MGS_TITLE_ADDRESS + 1]

		; -- Ȗ݂邩mF
		ld		a, [hl]
		cp		a, ' '
		jr		nc, do_title_copy

		; -- Ȗ݂Ȃꍇ͑̕\ "No title (file name)"
		push	ix
		pop		hl
		ld		de, grp_no_title_file_name
		ld		b, 8
filename_copy_loop:
		ld		a, [hl]
		cp		a, '.'
		jr		z, filename_copy_loop_exit
		ld		[de], a
		inc		hl
		inc		de
		djnz	filename_copy_loop
filename_copy_loop_exit:
		ld		hl, grp_no_title

do_title_copy:
		ld		de, grp_draw_file_line
		ld		b, 62
title_copy_loop:
		ld		a, [hl]
		cp		a, ' '
		jr		c, title_copy_loop_exit
		ld		[de], a
		inc		hl
		inc		de
		djnz	title_copy_loop
title_copy_loop_exit:

		; `悷
		pop		bc
		push	bc
		ld		a, b
		call	grp_get_line_address
		ld		de, grp_draw_file_line
		call	draw_string
		pop		bc
		inc		c
		inc		b
		ld		a, c
		ld		hl, fl_files
		cp		a, [hl]
		ld		a, b
		jr		z, clear_space
		cp		a, 11
		jp		c, loop
clear_space_exit:
		call	grp_select_line
		jp		grp_update_scroll_bar
clear_space::
		cp		a, 11					; 0`10LC, zI
		jp		nc, clear_space_exit
		push	af
		call	grp_clear_line
		pop		af
		inc		a
		jr		clear_space

		; fBNg̏ꍇ
draw_directory:
		; -- Lobt@փRs[
		ld		hl, grp_directory_mark
		ld		de, grp_draw_file_line
		ld		bc, 6
		ldir
		push	ix
		pop		hl
		ld		b, 62 - 6
		jr		title_copy_loop
		endscope

; ==============================================================================
;	grp_get_top_entry_number
;	ԏɕ\Gg̔ԍ߂
;	input)
;		[fl_files] .......... ꗗ\Ɋi[Ăt@C
;		[grp_select_file] ... I𒆂̃t@C̔ԍ (ꗗ\̒̉Ԗڂ)
;		[grp_top_file] ...... ݈ԏɕ\Ăt@C̔ԍ
;	output)
;		[grp_top_file] ......... ԏ̃t@C̔ԍ
;		[grp_select_line_no] ... I𒆂̃Cԍ
;		Zf ..................... 1: t@CPȂ, 0: ʏ
;		a ...................... 0: t@C, 1: XN[Ȃ, 2: ɃXN[, 3: ɃXN[
; ==============================================================================
		scope	grp_get_top_entry_number
grp_get_top_entry_number::
		ld		a, [fl_files]
		or		a, a
		ret		z
		; ꗗɑ݂t@C 11ȉ̏ꍇAɑS\
		ld		a, [grp_top_file]
		ld		b, a
		ld		a, [grp_select_file]
		cp		a, b				; [grp_select_file] < [grp_top_file]
		jr		c, up_move

		; [grp_select_file] >= [grp_top_file] ̏ꍇ
		ld		c, a
		ld		a, b
		add		a, 10
		cp		a, c				; ([grp_top_file] + 10) < [grp_select_file]
		jr		c, down_move

		; [grp_select_file] >= [grp_top_file] && ([grp_top_file] + 10) >= [grp_select_file] ̏ꍇ (XN[Ȃꍇ)
		ld		a, [grp_top_file]
		ld		b, a
		ld		a, c
		sub		a, b
		ld		[grp_select_line_no], a
		inc		a
		ld		a, 1
		ret							; Zf = 0

		; [grp_select_file] < [grp_top_file] ̏ꍇ́A [grp_top_file] = [grp_select_file] ɂ
up_move:
		ld		[grp_top_file], a
		xor		a, a
		ld		[grp_select_line_no], a
		inc		a
		ld		a, 2
		ret							; Zf = 0

		; ([grp_top_file] + 10) < [grp_select_file] ̏ꍇ́A [grp_top_file] = [grp_select_file] - 10 ɂ
down_move:
		ld		a, c
		sub		a, 10
		ld		[grp_top_file], a
		ld		a, 10
		ld		[grp_select_line_no], a
		ld		a, 3
		ret							; Zf = 0
		endscope

; ==============================================================================
;	[vJEg̕\XV
;	input)
;		a ..... [vJEg
;	output)
;		--
;	break)
;		all
; ==============================================================================
		scope	grp_update_loop_count
grp_update_loop_count::
		ld		hl, 242 * 8
		jp		draw_number
		endscope

; ==============================================================================
;	[h\XV
;	input)
;		a ..... [hԍ (0: Normal, 1: Random, 2: Repeat)
;	output)
;		--
;	break)
;		all
; ==============================================================================
		scope	grp_update_mode_info
grp_update_mode_info::
		add		a, a
		add		a, a
		add		a, a
		ld		l, a
		ld		h, 0
		ld		de, mgsp_normal_mode
		add		hl, de
		ex		de, hl
		ld		hl, 200 * 8
		jp		draw_string
		endscope

; ==============================================================================
;	\[g[h\XV
;	input)
;		a ..... [hԍ (0: Entry, 1: Title)
;	output)
;		--
;	break)
;		all
; ==============================================================================
		scope	grp_update_sort_mode_info
grp_update_sort_mode_info::
		add		a, a
		add		a, a
		add		a, a
		ld		l, a
		ld		h, 0
		ld		de, mgsp_order_entry
		add		hl, de
		ex		de, hl
		ld		hl, 179 * 8
		jp		draw_string
		endscope

; ==============================================================================
;	draw_number
;	l`悷
;	input)
;		hl .... `悷p^[WFl[^[e[ũAhX
;		a ..... `悷鐔l (0`99)
;	output)
;		--
;	break)
;		all
; ==============================================================================
		scope	draw_number
draw_number::
		ld		b, 0
		cp		a, 50
		jp		c, skip1
		sub		a, 50
		ld		b, 5
skip1:
		cp		a, 30
		jp		c, skip2
		sub		a, 30
		inc		b
		inc		b
		inc		b
skip2:
		cp		a, 20
		jp		c, skip3
		sub		a, 20
		inc		b
		inc		b
skip3:
		cp		a, 10
		jp		c, skip4
		sub		a, 10
		inc		b
skip4:
		add		a, '0'
		ld		[s_number + 1], a
		ld		a, b
		ld		b, '0'
		or		a, a
		jp		nz, skip_number
		ld		b, ' '
skip_number:
		add		a, b
		ld		[s_number], a
		ld		de, s_number
		jp		draw_string
s_number:
		db		0, 0, 0
		endscope

; ==============================================================================
;	draw_string
;	`悷
;	input)
;		hl .... `悷p^[WFl[^[e[ũAhX
;		de .... `悷镶 (MAX 30, ASCIIZ)
;	output)
;		--
;	break)
;		all
; ==============================================================================
		scope	draw_string
draw_string::
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT
		call	put_string
		ld		a, b
		or		a, a
		ret		z						;  0 Ȃ甲
		ld		c, vdp_port0
transfer_loop:
		outi
		jr		nz, transfer_loop		; OTIRƑ
		ret
		endscope

; ==============================================================================
;	grp_draw_keyboard_spot
;	L[{[h̋P_`悷
; ==============================================================================
		scope	grp_draw_keyboard_spot
grp_draw_keyboard_spot::
		ld		hl, 0x3800
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT

		ld		hl, mgsp_keyboard_spot_pattern
		ld		bc, (4 << 8) | vdp_port0
		ld		d, 0
loop_row:
		push	bc
		ld		b, 7
loop_column:
		ld		a, [hl]
		out		[c], a
		inc		hl
		push	bc
		ld		b, 14
		out		[c], a
loop_blank:
		nop						; VDP҂
		nop						; VDP҂
		nop						; VDP҂
		out		[c], d
		djnz	loop_blank
		pop		bc
		djnz	loop_column

		ld		b, 16
loop_right_blank:
		nop						; VDP҂
		nop						; VDP҂
		nop						; VDP҂
		out		[c], d
		djnz	loop_right_blank
		pop		bc
		djnz	loop_row
		ret
		endscope

; ==============================================================================
;	grp_update_keyboard_spot
;	L[{[h̋P_XV
;	input)
;		track_work_area .. gbN[NGA̐擪AhX
;		track_size ....... gbN[NGA1gbÑoCg
;	output)
;		a ................ t̃gbN̐
; ==============================================================================
		scope	grp_update_keyboard_spot
grp_update_keyboard_spot::
		ld			iy, [mgs_id_trwadr]
		; SNA
		ld		hl, mgsp_keyboard_spot_pattern
		ld		de, mgsp_keyboard_spot_pattern + 1
		ld		bc, 28 - 1
		xor		a, a
		ld		[hl], a
		ldir

		; g[𓾂
		ld		ix, grp_track_volume
		ld		b, 17								; 17[tracks]
track_loop:
		push	bc
		ld		a, [iy + mgs_twa_track_state]		; 0:OFF, 1:ON, 2:MUTE
		dec		a
		jp		nz, track_note_off					; OFF ܂  Ȃ track_note_off 

		ld		a, [iy + mgs_twa_gate_time_cnt + 1]
		or		a, a
		jp		m, track_note_off					; GATE^CJE^Ȃ track_note_off 
		or		a, [iy + mgs_twa_gate_time_cnt + 0]
		jp		z, track_note_off					; GATE^CJE^ 0Ȃ track_note_off 

		ld		a, 1
		ld		[ix + 0], a							; Key on
		ld		a, [iy + 0x15]						; IN^[u (0`7)

		; A = 12 * A = (2 * 2 * 2 + 2 * 2) * A
		add		a, a
		add		a, a
		ld		e, a
		add		a, a
		add		a, e
		ld		e, a

		ld		a, [iy + 0x3A]
		cp		a, 13				; x
		jp		z, track_note_off

		add		a, e				; A = : 0`95
		ld		e, a
		ld		d, 0

		ld		hl, mgsp_tone_to_keyboard
		add		hl, de
		add		hl, de

		ld		e, [hl]
		inc		hl
		ld		a, [hl]

		ld		hl, mgsp_keyboard_spot_pattern
		add		hl, de
		or		a, [hl]
		ld		[hl], a

track_end:
		ld		de, [mgs_id_trwsiz]
		add		iy, de
		pop		bc
		inc		ix
		inc		ix
		inc		ix
		djnz	track_loop
		call	grp_draw_keyboard_spot
		call	grp_update_track_volume
		ret

track_note_off:
		xor		a, a
		ld		[ix + 0], a				; Key off
		jp		track_end
		endscope

; ==============================================================================
;	grp_get_line_address
;	t@Cꗗʂ̃p^WFlAhX߂
;	input)
;		a ....... sԍ 0~10
;	output)
;		hl ...... p^WFl̃AhX
;	break)
;		f, de
; ==============================================================================
		scope	grp_get_line_address
grp_get_line_address::
		ld		l, a
		ld		h, 0
		ld		de, mgsp_filename_line
		add		hl, de
		ld		l, [hl]
		ld		h, 0
		add		hl, hl
		add		hl, hl
		add		hl, hl
		ld		de, 0x800
		add		hl, de
		cp		a, 5
		ret		c
		add		hl, de
		ret
		endscope

; ==============================================================================
;	grp_set_line_address
;	t@Cꗗʂ̃p^WFlAhXVDPɃZbg
;	input)
;		a ....... sԍ 0~10
;	output)
;		--
;	break)
;		af, de, ix, iy
; ==============================================================================
		scope	grp_set_line_address
grp_set_line_address::
		call	grp_get_line_address
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT
		ret
		endscope

; ==============================================================================
;	grp_clear_line
;	t@Cꗗʂ̎w胉CNA
;	input)
;		a ....... sԍ 0~10
;	output)
;		--
;	break)
;		af, bc, de, hl, ix, iy
; ==============================================================================
		scope	grp_clear_line
grp_clear_line::
		call	grp_get_line_address
		; p^WFl 0x00NA
		ld		b, 31 * 8
		ld		d, 0
		call	memset_v
		; J[e[u 0xF0NA
		ld		bc, 0x2000
		add		hl, bc
		ld		b, 31 * 8
		ld		d, 0xF0
		call	memset_v
		ret
		endscope

; ==============================================================================
;	grp_select_line
;	t@Cꗗʂ̎w̍sI\ɕύX
;	input)
;		[grp_select_line_no] ... ݂̑Is
;	output)
;		--
;	break)
;		af, de, ix, iy
; ==============================================================================
		scope	grp_select_line
grp_select_line::
		ld		a, [grp_select_line_no]
		call	grp_get_line_address
		ld		de, 0x2000
		add		hl, de

		ld		a, [grp_top_file]
		ld		b, a
		ld		a, [grp_play_file]
		sub		a, b
		ld		c, a
		ld		a, [grp_select_line_no]
		cp		a, c

		; IԂ̐F Oi , wi CgCG[
		ld		d, 0x0B
		jr		nz, skip1

		; IԂĐ̐F Oi , wi Cgbh
		ld		d, 0x09

skip1:
		ld		b, 31 * 8
		jp		memset_v
		endscope

; ==============================================================================
;	grp_playing_line
;	t@Cꗗʂ̍Đ̋Ȃ̍s\ɕύX
;	input)
;		[grp_play_file] ... ݍĐ̋Ȕԍ (Io[̈ʒuȂ牽Ȃ)
;	output)
;		--
;	break)
;		af, de, ix, iy
; ==============================================================================
		scope	grp_playing_line
grp_playing_line::
		ld		a, [grp_top_file]
		ld		b, a
		ld		a, [grp_play_file]
		sub		a, b
		ld		c, a
		ld		a, [grp_select_line_no]
		cp		a, c
		ret		z
		ld		a, c
		cp		a, 11
		ret		nc

		call	grp_get_line_address
		ld		de, 0x2000
		add		hl, de

		; Đ̐F Oi , wi _[Nbh
		ld		d, 0x06
		ld		b, 31 * 8
		jp		memset_v
		endscope

; ==============================================================================
;	grp_unselect_playing_line
;	t@Cꗗʂ̍Đ̋Ȃ̍s\ɕύX
;	input)
;		[grp_play_file] ... ݍĐ̋Ȕԍ (Io[̈ʒuȂ牽Ȃ)
;	output)
;		--
;	break)
;		af, de, ix, iy
; ==============================================================================
		scope	grp_unselect_playing_line
grp_unselect_playing_line::
		ld		a, [grp_top_file]
		ld		b, a
		ld		a, [grp_play_file]
		sub		a, b
		ld		c, a
		ld		a, [grp_select_line_no]
		cp		a, c
		ret		z
		ld		a, c
		cp		a, 11
		ret		nc

		call	grp_get_line_address
		ld		de, 0x2000
		add		hl, de

		; Đ̐F Oi , wi 
		ld		d, 0xF0
		ld		b, 31 * 8
		jp		memset_v
		endscope

; ==============================================================================
;	grp_unselect_line
;	t@Cꗗʂ̎w̍sI\ɕύX
;	input)
;		[grp_select_line_no] ... ݂̑Is
;	output)
;		--
;	break)
;		af, de, ix, iy
; ==============================================================================
		scope	grp_unselect_line
grp_unselect_line::
		ld		a, [grp_select_line_no]
		call	grp_get_line_address
		ld		de, 0x2000
		add		hl, de

		ld		b, 31 * 8
		; IԂ̐F Oi , wi 
		ld		d, 0xF0
		jp		memset_v
		endscope

; ==============================================================================
;	grp_update_track_volume
;	gbNƂ̉ʕ\XV
;	input)
;		track_work_area .. gbN[NGA̐擪AhX
;		track_size ....... gbN[NGA1gbÑoCg
;	output)
;		a ................ t̃gbN̐
; ==============================================================================
		scope	grp_update_track_volume
grp_update_track_volume::
		ld		hl, 0x0000
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT

		; g[𓾂
		ld		c, vdp_port0
		ld		iy, [mgs_id_trwadr]
		ld		hl, grp_track_volume
		ld		b, 17				; 17[tracks]
track_loop:
		push	bc
		ld		a, [hl]				; flag (current time)
		ld		b, a
		inc		hl
		ld		a, [hl]				; flag (last time)
		ld		[hl], b
		inc		hl
		sub		a, b				; Key on  last=0(A), current=1(B) 0-1 = -1
		jp		c, track_key_on
		jp		nz, track_key_off
track_decay:
		ld		a, [hl]
		or		a, a
		jp		z, track_key_off
		dec		a
		ld		[hl], a
		srl		a
		ld		b, a
		ld		d, [iy + 0x17]		; track volume
		jp		skip1

track_key_off:
		ld		b, 0
		ld		d, [iy + 0x17]		; track volume
		jp		skip1

track_key_on:						; key on, off ̃tO͌Օ\XV track_note_off ŃNA
		ld		a, [iy + 0x17]		; track volume
		ld		d, a
		ld		b, a
		add		a, a
		ld		[hl], a
skip1:
		call	draw_track_volume
		ld		de, [mgs_id_trwsiz]
		add		iy, de
		inc		hl
		pop		bc
		djnz	track_loop

		; track on/off switch
		ld		hl, 0x1800 + (5 * 32 + 15)
		ld		ix, SETWRT
		ld		iy, [exptbl - 1]
		call	CALSLT

		ld		c, vdp_port0
		ld		iy, [mgs_id_trwadr]
		ld		de, [mgs_id_trwsiz]
		ld		b, 17				; 17[tracks]
		ld		h, 0
track_sw_loop:
		ld		a, [iy + 0x00]		; track status  0:OFF, 1:ON, 2:MUTE
		or		a, a
		jp		z, track_no_active
		inc		h
track_no_active:
		add		a, 68
		out		[c], a
		add		iy, de
		djnz	track_sw_loop
		ld		a, h
		ret

draw_track_volume:					; B=݂̉, D=track volume ŌĂ
		inc		b
		ld		a, 15
draw_track_volume_loop:
		ld		e, 0xDE
		cp		a, d
		jp		z, draw_track_volume_skip1
		cp		a, b
		jp		c, draw_track_volume_skip1
		ld		e, 0xC0
draw_track_volume_skip1:
		nop							; VDP҂
		nop							; VDP҂
		nop							; VDP҂
		out		[c], e
		ld		e, 0
		nop							; VDP҂
		nop							; VDP҂
		nop							; VDP҂
		dec		a
		out		[c], e
		jp		p, draw_track_volume_loop
		ret
		endscope

; ==============================================================================
;	WORKAREA
; ==============================================================================
grp_directory_mark::
		ds		"[DIR] "
grp_top_file::
		db		255
grp_select_file::
		db		0
grp_play_file::
		db		0
grp_select_line_no::
		db		0
grp_no_title::
		ds		"No title ["
grp_no_title_file_name::
		ds		"        "
		ds		"]"
		db		0
mgsp_name::
		ds		"MGSP"
mgsp_version::
		ds		" Version 2.00alpha "
		db		0
mgsp_copyright::
		ds		"Copyright (C)HRA!"
		db		0
mgsp_order::
		ds		"Order  :"
		db		0
mgsp_order_entry::			; 8bytes
		ds		"Entry"
		db		0, 0, 0
mgsp_order_title::			; 8bytes
		ds		"Title"
		db		0, 0, 0
mgsp_order_filename::		; 8bytes
		ds		"F.Name"
		db		0, 0
mgsp_volume::
		ds		"Volume :"
		db		0
mgsp_automode::
		ds		"Mode :"
		db		0
mgsp_normal_mode::			; 8bytes
		ds		"Normal"
		db		0, 0
mgsp_random_mode::			; 8bytes
		ds		"Random"
		db		0, 0
mgsp_repeat_mode::			; 8bytes
		ds		"Repeat"
		db		0, 0
mgsp_ch::
		ds		" 1 2 3 4 5 6 7 8 9 A B C D E F G H"
		db		0
mgsp_loop_count::
		ds		"Loop :"
		db		0
mgsp_filename::
		ds		"Filename: "
		db		0
mgsp_filename_line::
		db		96, 127, 158, 189, 220, 6, 37, 68, 99, 130, 161

grp_track_volume:					; +0: flag current(0:Key off, 1:Key on), flag backup, +1: volume level
		db		0, 0, 0				; track 1
		db		0, 0, 0				; track 2
		db		0, 0, 0				; track 3
		db		0, 0, 0				; track 4
		db		0, 0, 0				; track 5
		db		0, 0, 0				; track 6
		db		0, 0, 0				; track 7
		db		0, 0, 0				; track 8
		db		0, 0, 0				; track 9
		db		0, 0, 0				; track A
		db		0, 0, 0				; track B
		db		0, 0, 0				; track C
		db		0, 0, 0				; track D
		db		0, 0, 0				; track E
		db		0, 0, 0				; track F
		db		0, 0, 0				; track G
		db		0, 0, 0				; track H

grp_volume_table::
		db		0b11111111, 0b11111110
		db		0b11111111, 0b11111100
		db		0b11111111, 0b11111000
		db		0b11111111, 0b11110000
		db		0b11111111, 0b11100000
		db		0b11111111, 0b11000000
		db		0b11111111, 0b10000000
		db		0b11111111, 0b00000000
		db		0b11111110, 0b00000000
		db		0b11111100, 0b00000000
		db		0b11111000, 0b00000000
		db		0b11110000, 0b00000000
		db		0b11100000, 0b00000000
		db		0b11000000, 0b00000000
		db		0b10000000, 0b00000000
		db		0b00000000, 0b00000000

grp_draw_file_line::
		; L pattern ́Aɕ`svɂȂ̂ŁAƗ̈Ƃčėp
mgsp_logo_pattern::
		db		0xF6, 0xFF, 0xDB, 0xDB, 0xDB, 0xDB, 0xDB, 0x00
		db		0x7F, 0x7F, 0x60, 0x6F, 0x63, 0x7F, 0x7F, 0x00
		db		0x7F, 0x7F, 0x70, 0x7F, 0x07, 0x7F, 0x7F, 0x00
		db		0x7F, 0x41, 0x5D, 0x41, 0x5F, 0x50, 0x70, 0x00

mgsp_logo_color::
		db		0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xE0, 0x00

mgsp_keyboard_pattern1::
		db		0x00, 0x00, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4
		db		0x00, 0x00, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C
		db		0x00, 0x00, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44
		db		0x00, 0x00, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C
		db		0x00, 0x00, 0x46, 0x46, 0x46, 0x46, 0x46, 0x46
		db		0x00, 0x00, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4
		db		0x00, 0x00, 0x46, 0x46, 0x46, 0x46, 0x46, 0x46

mgsp_keyboard_pattern2::
		db		0xC4, 0xC4, 0xC4, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE
		db		0x6C, 0x6C, 0x6C, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE
		db		0x44, 0x44, 0x44, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE
		db		0x6C, 0x6C, 0x6C, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE
		db		0x46, 0x46, 0x46, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE
		db		0xC4, 0xC4, 0xC4, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE
		db		0x46, 0x46, 0x46, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE

mgsp_keyboard_color::
		db		0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xE0

mgsp_track_sw_pattern::
		db		0xFE, 0x82, 0x82, 0x82, 0x82, 0x82, 0xFE, 0x00
		db		0xFE, 0x82, 0xBA, 0xBA, 0xBA, 0x82, 0xFE, 0x00
		db		0xFE, 0x82, 0xAA, 0x92, 0xAA, 0x82, 0xFE, 0x00
mgsp_track_sw_color::
		db		0x50, 0x70, 0x70, 0x50, 0x40, 0x40, 0x40, 0x00
		db		0x80, 0x90, 0x90, 0x80, 0x60, 0x60, 0x60, 0x00
		db		0x20, 0x30, 0x30, 0x20, 0xC0, 0xC0, 0xC0, 0x00

mgsp_function_key_pattern1::
		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	; F1
		db		0x00, 0xFF, 0x9F, 0x87, 0x81, 0x87, 0x9F, 0xFF
		db		0x00, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE

		db		0x00, 0xFF, 0xC3, 0xC0, 0xC0, 0xC0, 0xC0, 0xFF	; F2
		db		0x00, 0xFF, 0xFF, 0x3F, 0x03, 0x00, 0x00, 0xFF
		db		0x00, 0xFE, 0xFE, 0xFE, 0xFE, 0x3E, 0x02, 0xFE

		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	; F3
		db		0x00, 0xFF, 0x83, 0x83, 0x83, 0x83, 0x83, 0xFF
		db		0x00, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE

		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	; F4
		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
		db		0x00, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE

		db		0x00, 0xFF, 0xDF, 0xCF, 0xC7, 0xDF, 0xC0, 0xFF	; F5
		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0xFF
		db		0x00, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0x2A, 0xFE

mgsp_function_key_pattern2::
		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	; F6
		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
		db		0x00, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE

		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	; F7
		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
		db		0x00, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE

		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	; F8
		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
		db		0x00, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE

		db		0x00, 0xFF, 0x85, 0xBE, 0x87, 0xBE, 0x85, 0xFF	; F9
		db		0x00, 0xFF, 0xD1, 0xBB, 0x7B, 0xBB, 0xD1, 0xFF
		db		0x00, 0xFE, 0x06, 0xDE, 0xDE, 0xDE, 0xDE, 0xFE

		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	; F10
		db		0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
		db		0x00, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE

mgsp_function_key_color::
		db		0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xE0

mgsp_volume_bar_color::
		db		0xF0, 0xE0, 0x70, 0x50, 0x50, 0x40, 0x40, 0x40
mgsp_volume_color::
		db		0x94, 0xF4, 0x94, 0x84, 0x64, 0x64, 0x84, 0x00

mgsp_scroll_bar_up_pattern::
		db		0xFF, 0xFF, 0xFF, 0xFF, 0xE7, 0xC3, 0x81, 0xFF

mgsp_scroll_bar_down_pattern::
		db		0xFF, 0x81, 0xC3, 0xE7, 0xFF, 0xFF, 0xFF, 0xFF

mgsp_sound_source_logo::
		db		0x02, 0x05, 0x04, 0x12, 0x01, 0x05, 0x02, 0x00		; SCC
		db		0x08, 0x14, 0x14, 0x51, 0x14, 0x14, 0x08, 0x00
		db		0x20, 0x50, 0x50, 0x44, 0x50, 0x50, 0x20, 0x00
		db		0xF3, 0xF1, 0xF4, 0xF6, 0xC7, 0x87, 0x8F, 0xFF		; MSX-MUSIC

mgsp_sound_source_logo_not_found_color::
		db		0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40

mgsp_sound_source_logo_found_color::
		db		0xE0, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xE0

mgsp_keyboard_spot_attrib::
		db		44 - 1, 1, 0, 8		; i
		db		44 - 1,33, 4, 8
		db		44 - 1,65, 8, 8
		db		44 - 1,97,12, 8
		db		38 - 1, 2,16, 8		; i
		db		38 - 1,34,20, 8
		db		38 - 1,66,24, 8
		db		38 - 1,98,28, 8
		db		28 - 1, 1,32, 8		; i
		db		28 - 1,33,36, 8
		db		28 - 1,65,40, 8
		db		28 - 1,97,44, 8
		db		22 - 1, 2,48, 8		; i
		db		22 - 1,34,52, 8
		db		22 - 1,66,56, 8
		db		22 - 1,98,60, 8

mgsp_keyboard_spot_pattern::
		db		0xAA				; i +0
		db		0xAA				; i +1
		db		0xAA				; i +2
		db		0xAA				; i +3
		db		0xAA				; i +4
		db		0xAA				; i +5
		db		0xAA				; i +6
		db		0xA2				; i +7
		db		0xA2				; i +8
		db		0x8A				; i +9
		db		0x8A				; i +10
		db		0x2A				; i +11
		db		0x28				; i +12
		db		0xA8				; i +13
		db		0xAA				; i +14
		db		0xAA				; i +15
		db		0xAA				; i +16
		db		0xAA				; i +17
		db		0xAA				; i +18
		db		0xAA				; i +19
		db		0xAA				; i +20
		db		0xA2				; i +21
		db		0xA2				; i +22
		db		0x8A				; i +23
		db		0x8A				; i +24
		db		0x2A				; i +25
		db		0x28				; i +26
		db		0xA8				; i +27

mgsp_tone_to_keyboard::
		db		0    , 0x80			; O0C  --> i
		db		7    , 0x80			; O0C# --> i
		db		0    , 0x20			; O0D  --> i
		db		7    , 0x20			; O0D# --> i
		db		0    , 0x08			; O0E  --> i
		db		0    , 0x02			; O0F  --> i
		db		7    , 0x02			; O0F# --> i
		db		1    , 0x80			; O0G  --> i
		db		8    , 0x80			; O0G# --> i
		db		1    , 0x20			; O0A  --> i
		db		8    , 0x20			; O0A# --> i
		db		1    , 0x08			; O0B  --> i
		db		1    , 0x02			; O1C  --> i
		db		8    , 0x02			; O1C# --> i
		db		2    , 0x80			; O1D  --> i
		db		9    , 0x80			; O1D# --> i
		db		2    , 0x20			; O1E  --> i
		db		2    , 0x08			; O1F  --> i
		db		9    , 0x08			; O1F# --> i
		db		2    , 0x02			; O1G  --> i
		db		9    , 0x02			; O1G# --> i
		db		3    , 0x80			; O1A  --> i
		db		10   , 0x80			; O1A# --> i
		db		3    , 0x20			; O1B  --> i
		db		3    , 0x08			; O2C  --> i
		db		10   , 0x08			; O2C# --> i
		db		3    , 0x02			; O2D  --> i
		db		10   , 0x02			; O2D# --> i
		db		4    , 0x80			; O2E  --> i
		db		4    , 0x20			; O2F  --> i
		db		11   , 0x20			; O2F# --> i
		db		4    , 0x08			; O2G  --> i
		db		11   , 0x08			; O2G# --> i
		db		4    , 0x02			; O2A  --> i
		db		11   , 0x02			; O2A# --> i
		db		5    , 0x80			; O2B  --> i
		db		5    , 0x20			; O3C  --> i
		db		12   , 0x20			; O3C# --> i
		db		5    , 0x08			; O3D  --> i
		db		12   , 0x08			; O3D# --> i
		db		5    , 0x02			; O3E  --> i
		db		6    , 0x80			; O3F  --> i
		db		13   , 0x80			; O3F# --> i
		db		6    , 0x20			; O3G  --> i
		db		13   , 0x20			; O3G# --> i
		db		6    , 0x08			; O3A  --> i
		db		13   , 0x08			; O3A# --> i
		db		6    , 0x02			; O3B  --> i

		db		0 +14, 0x80			; O4C  --> i
		db		7 +14, 0x80			; O4C# --> i
		db		0 +14, 0x20			; O4D  --> i
		db		7 +14, 0x20			; O4D# --> i
		db		0 +14, 0x08			; O4E  --> i
		db		0 +14, 0x02			; O4F  --> i
		db		7 +14, 0x02			; O4F# --> i
		db		1 +14, 0x80			; O4G  --> i
		db		8 +14, 0x80			; O4G# --> i
		db		1 +14, 0x20			; O4A  --> i
		db		8 +14, 0x20			; O4A# --> i
		db		1 +14, 0x08			; O4B  --> i
		db		1 +14, 0x02			; O5C  --> i
		db		8 +14, 0x02			; O5C# --> i
		db		2 +14, 0x80			; O5D  --> i
		db		9 +14, 0x80			; O5D# --> i
		db		2 +14, 0x20			; O5E  --> i
		db		2 +14, 0x08			; O5F  --> i
		db		9 +14, 0x08			; O5F# --> i
		db		2 +14, 0x02			; O5G  --> i
		db		9 +14, 0x02			; O5G# --> i
		db		3 +14, 0x80			; O5A  --> i
		db		10+14, 0x80			; O5A# --> i
		db		3 +14, 0x20			; O5B  --> i
		db		3 +14, 0x08			; O6C  --> i
		db		10+14, 0x08			; O6C# --> i
		db		3 +14, 0x02			; O6D  --> i
		db		10+14, 0x02			; O6D# --> i
		db		4 +14, 0x80			; O6E  --> i
		db		4 +14, 0x20			; O6F  --> i
		db		11+14, 0x20			; O6F# --> i
		db		4 +14, 0x08			; O6G  --> i
		db		11+14, 0x08			; O6G# --> i
		db		4 +14, 0x02			; O6A  --> i
		db		11+14, 0x02			; O6A# --> i
		db		5 +14, 0x80			; O6B  --> i
		db		5 +14, 0x20			; O7C  --> i
		db		12+14, 0x20			; O7C# --> i
		db		5 +14, 0x08			; O7D  --> i
		db		12+14, 0x08			; O7D# --> i
		db		5 +14, 0x02			; O7E  --> i
		db		6 +14, 0x80			; O7F  --> i
		db		13+14, 0x80			; O7F# --> i
		db		6 +14, 0x20			; O7G  --> i
		db		13+14, 0x20			; O7G# --> i
		db		6 +14, 0x08			; O7A  --> i
		db		13+14, 0x08			; O7A# --> i
		db		6 +14, 0x02			; O7B  --> i
