; ==============================================================================
;	MGSP v2.0
; ------------------------------------------------------------------------------
;	Date		Author	Ver.	Description
; ==============================================================================
		include	"msxbios.asm"
		include	"msxdos1.asm"
		include	"msxdos2.asm"
		include	"mgsdrv_api.asm"

		org		0x100
; ==============================================================================
entry::
		ld			sp, [TPA_BOTTOM]
		call		mgsp_init

; ==============================================================================
; C[v
; ==============================================================================
		scope		mgsp_main_loop
main_loop:
		; 荞ݔ҂
		call		change_mgsdrv_slot
		halt										; 荞ݔ҂

		call		mgsp_check_music_change
		call		grp_update_keyboard_spot		; A ɉғ̃gbNԂ
		call		mgsp_check_music_stop
		call		mgsp_check_key
		jp			main_loop
		endscope

; ==============================================================================
; Wo͂Ƀo[WbZ[W\
; ==============================================================================
		scope		show_version_message
show_version_message::
		ld			de, mgsp_name
		call		puts
		ld			de, msg_ret
		call		puts
		ld			de, mgsp_copyright
		call		puts
		ld			de, msg_ret
		jp			puts
		endscope

; ==============================================================================
; 샂[hύX
; ==============================================================================
		scope		change_mode
change_mode::
		ld			a, [play_mode]
		inc			a
		cp			a, 3
		jr			nz, skip1
		xor			a, a
skip1:
		ld			[play_mode], a
		jp			grp_update_mode_info
		endscope

; ==============================================================================
; ̋ȂĐ
; ==============================================================================
		scope		start_next_music
start_next_music::
		; t@CP݂Ȃꍇ͉Ȃ
		ld			a, [fl_files]
		or			a, a
		ret			z
		ld			b, a

		; 샂[h𔻕
		ld			a, [play_mode]
		or			a, a
		jp			z, normal_mode
		dec			a
		jp			z, random_mode
repeat_mode:
		ld			a, [playing_music_number]
		jr			check_and_play

random_mode:
		call		get_random			; b ͕ۑ
adjust_random_max:
		cp			a, b
		jr			c, check_and_play
		sub			a, b
		jr			adjust_random_max

normal_mode:
		; Đ̋Ȃ̎̔ԍ𓾂
		ld			a, [playing_music_number]
change_next:
		inc			a
		cp			a, b
		ret			z

check_and_play:
		; fBNg?
		ld			c, a
		call		get_current_file_entry
		ld			de, 13
		add			hl, de
		ld			a, [hl]
		and			a, FIB_ATTR_DIRECTORY
		ld			a, c
		jr			nz, change_next
		call		play_new_music
		ret
		endscope

; ==============================================================================
; 
; ==============================================================================
		scope		mgsp_init
mgsp_init::
		; Show version information
		call		show_version_message

		; Initialize MemoryMapper
		call		mmap_init
		ld			de, msg_error_mmap_not_found
		jp			z, g_error_exit

		; check installed MGSDRV
		call		check_mgsdrv
		ld			de, msg_error_mgsdrv_not_found
		jp			nz, g_error_exit

		; show MGSDRV version
		call		change_mgsdrv_slot
		ld			de, msg_detect
		call		puts

		ld			a, [mgs_id_mgsver + 1]
		ld			hl, msg_1byte_hex
		call		dec_to_hex

		ld			de, msg_1byte_hex + 1
		call		puts

		ld			c, D1F_CONOUT
		ld			e, '.'
		call		bdos

		ld			a, [mgs_id_mgsver]
		ld			hl, msg_1byte_hex
		call		dec_to_hex

		ld			de, msg_1byte_hex
		call		puts

		ld			de, msg_ret
		call		puts

		; show OPLL slot number
		ld			de, msg_opll_slot_num
		call		puts
		ld			ix, [mgs_id_mibadr]
		ld			a, [ix + 0]
		call		put_slot_num
		ld			de, msg_ret
		call		puts

		; show SCC slot number
		ld			de, msg_scc_slot_num
		call		puts
		ld			ix, [mgs_id_mibadr]
		ld			a, [ix + 1]
		call		put_slot_num
		ld			de, msg_ret
		call		puts

		; process command line
		call		process_of_commandline
		jp			nz, exit_command_line

		;  GUINm

		; initialize kanji driver
		call		kanji_init
		or			a, a
		jr			z, kanji_init_no_error

		ld			de, msg_not_enough_memory
		dec			a
		jp			z, g_error_exit

		ld			de, msg_cannot_read_kfont
		jp			g_error_exit
kanji_init_no_error:

		call		grp_init
		ld			a, [master_volume]
		call		grp_update_master_volume
		ld			a, [loop_counter]
		call		grp_update_loop_count
		ld			a, [sort_mode]
		call		grp_update_sort_mode_info
		ld			a, [play_mode]
		call		grp_update_mode_info
		call		change_mgsdrv_slot

		xor			a, a
		ld			[mgs_music_title], a

		call		fl_update_entries
		ld			a, 1
		call		grp_update_file_list
		call		change_mgsdrv_slot
		call		clear_mgsdrv_track_work
		call		init_function_keys
		ret
		endscope

; ==============================================================================
; L[͂Ƃɉ
; ==============================================================================
		scope		mgsp_check_key
mgsp_check_key::
		; L[obt@`FbN
		ld			ix, CHSNS
		ld			iy, [exptbl - 1]
		call		CALSLT
		jp			z, skip_key_input

		; L[͂ɂď
		ld			ix, CHGET
		call		CALSLT
		call		toupper
		ld			hl, keymap_table
		call		call_keymap
skip_key_input:

		; WCXeBbÑL[s[g
		ld			a, [joy_key_wait]
		or			a, a
		jr			z, joy_key_repeat
		dec			a
		ld			[joy_key_wait], a
joy_key_repeat:

		; WCXeBbN͂ɂď
		ld			a, 1
		ld			ix, GTSTCK
		call		CALSLT

		ld			b, a
		ld			a, [joy_last_stick]
		cp			a, b					; O̓͂ƓH
		ld			a, 30					; ͂ wait  30/60[sec]
		jr			nz, joy_key_affect

		ld			a, [joy_key_wait]		; OƓ͓ŁA wait  0H
		or			a, a
		jr			nz, skip_joy_key
		ld			a, 4					; s[gԊu wait  4/60[sec]
joy_key_affect:
		ld			[joy_key_wait], a
		ld			a, b					; A = STICK(1)
		ld			[joy_last_stick], a
		ld			hl, joymap_table
		call		call_keymap
skip_joy_key:

		; WCXeBbÑ{^ɂď
		ld			a, 1
		ld			ix, GTTRIG
		call		CALSLT

		ld			b, a
		ld			a, [joy_last_trigger]
		or			a, a
		ld			a, b
		ld			[joy_last_trigger], a
		jr			nz, skip_joy_trigger
		or			a, a
		call		nz, play_current_music
skip_joy_trigger:
		ret
		endscope

; ==============================================================================
; AWX^ƃL[}bve[uɏ]ăTu[`R[
; input)
;	A .... L[R[h
;	HL ... L[}bve[ũAhX
; break)
;	all
; ==============================================================================
		scope		call_keymap
call_keymap::
		ld			de, 3
keymap_loop:
		ld			b, [hl]
		inc			b
		ret			z						; terminator Ȃ甲
		dec			b
		cp			a, b
		jp			z, call_keymap_routine
		add			hl, de
		jp			keymap_loop
call_keymap_routine:
		inc			hl
		ld			e, [hl]
		inc			hl
		ld			d, [hl]
		ex			de, hl
		jp			hl
		endscope

; ==============================================================================
; tԊĎ
; ==============================================================================
		scope		mgsp_check_music_change
mgsp_check_music_change::
		; tI`FbN
		ld			a, [play_state]				; A = 0: ~, 1: ̋ȍĐ҂, 2: tF[hAEg, 3: Đ
		or			a, a
		ret			z							; ~Ȃ牽Ȃ
		dec			a
		jp			z, play_next_music			; ̋ȍĐ҂Ȃ玟̋ȂĐ
		dec			a
		jp			z, wait_fadeout				; tF[hAEgȂtF[hAEg`FbN
		; t񐔂 loop_counter ɒB?
		ld			a, [play_mode]
		cp			a, 2						; repeat mode ȂAloop񐔃`FbN͂Ȃ
		ret			z
		ld			hl, [mgs_id_mibadr]
		ld			de, mgs_mib_loopct
		add			hl, de
		ld			a, [hl]
		ld			hl, loop_counter
		cp			a, [hl]
		ret			c							; BĂȂȂ牽Ȃ
		call		start_fadeout
		ret
		; tF[hAEg
wait_fadeout:
		ld			a, [fadeout_volume]
		inc			a
		ld			[fadeout_volume], a
		jp			z, fadeout_end
		srl			a
		srl			a
		srl			a
		srl			a
		call		mgs_msvst
		ei
		ret
fadeout_end:
		; ̋Ȃ̍Đ҂֑J
		ld			a, 1
		ld			[play_state], a
		call		stop_music
		ld			a, [master_volume]
		call		mgs_msvst
		ei
		ret

play_next_music:
		; ̋ȂĐ
		call		start_next_music
		ret
		endscope

; ==============================================================================
; Ȃ̍Đ~`FbN
; input)
;	A .... Number of active tracks
; ==============================================================================
		scope		mgsp_check_music_stop
mgsp_check_music_stop::
		or			a, a
		ret			nz					; Đ̃gbNcĂ̂ŉȂ

		ld			a, [play_state]
		or			a, a
		ret			z					; ĐĂȂԂȂ̂ŉȂ

		; ̋ȂĐԂɑJڂ
		ld			a, 1
		ld			[play_state], a
		ret
		endscope

; ==============================================================================
; 𓾂
; ==============================================================================
		scope		get_random
get_random::
		ld			a, [random_seed1]
		rlca
		xor			a, 0x24
		ld			[random_seed1], a
		ld			d, a
		ld			a, [random_seed2]
		rrca
		xor			a, 0x41
		ld			[random_seed2], a
		xor			a, d
		add			a, 0x73
		ret
		endscope

; ==============================================================================
; fBNgGgŃ\[g
; ==============================================================================
		scope		sort_by_entry
sort_by_entry::
		call		fl_sort_normal

		ld			a, 1
		call		grp_update_file_list
		call		change_mgsdrv_slot

		xor			a, a
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; ȖŃ\[g
; ==============================================================================
		scope		sort_by_title
sort_by_title::
		call		fl_sort_title

		ld			a, 1
		call		grp_update_file_list
		call		change_mgsdrv_slot

		ld			a, 1
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; t@CŃ\[g
; ==============================================================================
		scope		sort_by_filename
sort_by_filename::
		call		fl_sort_filename

		ld			a, 1
		call		grp_update_file_list
		call		change_mgsdrv_slot

		ld			a, 2
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; tF[hAEgJn
; ==============================================================================
		scope		start_fadeout
start_fadeout::
		ld			a, [play_state]
		cp			a, 3
		ret			nz
		ld			a, [master_volume]
		add			a, a
		add			a, a
		add			a, a
		add			a, a
		ld			[fadeout_volume], a
		ld			a, 2
		ld			[play_state], a
		ret
		endscope

; ==============================================================================
; ֈړ
; ==============================================================================
		scope		up_select
up_select::
		ld			a, [grp_select_file]
		or			a, a
		ret			z						; łɈԏȂ牽Ȃ
		dec			a
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; ֈړ
; ==============================================================================
		scope		down_select
down_select::
		ld			a, [fl_files]
		ld			b, a
		ld			a, [grp_select_file]
		inc			a
		cp			a, b
		ret			nc						; łɈԉȂ牽Ȃ
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; y[WAbv
; ==============================================================================
		scope		left_select
left_select::
		ld			a, [grp_select_file]
		or			a, a
		ret			z						; łɈԏȂ牽Ȃ
		sub			a, 9
		jr			nc, left_select_clip
		xor			a, a
left_select_clip:
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; y[W_E
; ==============================================================================
		scope		right_select
right_select::
		ld			a, [fl_files]
		ld			b, a
		ld			a, [grp_select_file]
		cp			a, b
		ret			z						; łɈԉȂ牽Ȃ
		add			a, 9
		cp			a, b
		jr			c, right_select_clip
		ld			a, b
		dec			a
right_select_clip:
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; y[Wgbv
; ==============================================================================
		scope		minus_select
minus_select::
		ld			a, [grp_select_file]
		or			a, a
		ret			z						; łɈԏȂ牽Ȃ
		xor			a, a
		ld			[grp_select_file], a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; y[W{g
; ==============================================================================
		scope		plus_select
plus_select::
		ld			a, [fl_files]
		ld			b, a
		ld			a, [grp_select_file]
		cp			a, b
		ret			z						; łɈԉȂ牽Ȃ
		ld			a, b
		dec			a
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; I
; ==============================================================================
		scope		exit_main_loop
exit_main_loop::
		call		stop_music
		call		grp_term
exit_command_line::
		call		mmap_change_to_tpa

		ld			ix, inifnk
		ld			iy, [exptbl - 1]
		call		CALSLT

exit_all::
		ld			b, 0
		ld			c, D2F_TERM
		jp			bdos
		endscope

; ==============================================================================
;	[vJEg
; ==============================================================================
		scope		loop_down
loop_down::
		ld			a, [loop_counter]
		dec			a
		ret			z						; ł 1 Ȃ牽Ȃ
		ld			[loop_counter], a
		call		grp_update_loop_count
		jp			change_mgsdrv_slot
		endscope

; ==============================================================================
;	[vJEg
; ==============================================================================
		scope		loop_up
loop_up::
		ld			a, [loop_counter]
		inc			a
		cp			a, 65
		ret			z						; ł 64 Ȃ牽Ȃ
		ld			[loop_counter], a
		call		grp_update_loop_count
		jp			change_mgsdrv_slot
		endscope

; ==============================================================================
;	}X^[ 
; ==============================================================================
		scope		master_volume_up
master_volume_up::
		ld			a, [master_volume]
		dec			a
		ret			m
		ld			[master_volume], a
		call		grp_update_master_volume
		ld			a, [master_volume]
		call		mgs_msvst
		ei
		ret
		endscope

; ==============================================================================
;	}X^[ 
; ==============================================================================
		scope		master_volume_down
master_volume_down::
		ld			a, [master_volume]
		inc			a
		cp			a, 16
		ret			nc
		ld			[master_volume], a
		call		grp_update_master_volume
		ld			a, [master_volume]
		call		mgs_msvst
		ei
		ret
		endscope

; ==============================================================================
;	t@NVL[
; ==============================================================================
		scope		init_function_keys
init_function_keys::
		ld			hl, 'P'
		ld			[fnkstr + 16 * 0], hl
		ld			hl, 'F'
		ld			[fnkstr + 16 * 1], hl
		ld			hl, 'S'
		ld			[fnkstr + 16 * 2], hl
		ld			hl, 0x08
		ld			[fnkstr + 16 * 4], hl
		ld			hl, 0x1B
		ld			[fnkstr + 16 * 8], hl
		ret
		endscope

; ==============================================================================
;	G[I
; ==============================================================================
		scope		g_error_exit
g_error_exit::
		ei
		push		de
		call		mmap_change_to_tpa
		pop			de

		call		puts

		ld			b, 1
		ld			c, D2F_TERM
		jp			bdos
		endscope

; ==============================================================================
; efBNgֈړ
; ==============================================================================
		scope		goto_parent_dir
goto_parent_dir::
		ld			ix, parent_dir
		jp			enter_directory
parent_dir:
		ds			".."
		db			0
		endscope

; ==============================================================================
;	I𒆂̋ȃf[^Đ
; ==============================================================================
		scope		play_current_music
play_current_music::
		ld			a, [grp_select_file]
play_new_music::
		push		af
		call		grp_unselect_playing_line
		pop			af
		ld			c, a
		ld			[grp_play_file], a
		call		get_current_file_entry
		ret			z							; t@C
		push		hl
		pop			ix
		ld			a, [ix + 13]
		and			a, FIB_ATTR_DIRECTORY
		jp			nz, enter_directory

		ld			a, c
		ld			[playing_music_number], a

		ex			de, hl
		push		de
		call		change_mgsdrv_slot
		pop			de
		call		load_mgs_file_and_show_title
		ld			a, [master_volume]
		call		mgs_msvst
		call		play_music
		; tԂɕύX
		ld			a, 3
		ld			[play_state], a
		xor			a, a
		call		grp_update_file_list
		ret

enter_directory::
		ld			c, D2F_CHDIR
		push		ix
		pop			de
		call		bdos

		; t@CXgXV
		call		fl_update_entries

		; J[\ԏɕύX
		xor			a, a
		ld			[grp_select_file], a
		ld			[playing_music_number], a

		; \XV
		dec			a
		ld			[grp_top_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
;	wv\
; ==============================================================================
		scope		show_help
show_help::
		ld			a, [option_h]
		or			a, a
		ret			z
show:
		ld			de, msg_help
		call		puts
		ret
		endscope

; ==============================================================================
;	R}hC
;	input)
;		[dma] .... Command line parameter
;	output)
;		Zf ....... 1: GUI, 0: CUI
; ==============================================================================
		scope		process_of_commandline
process_of_commandline::
		call		check_options

		ld			a, [target_file_name]
		ld			hl, option_h
		or			a, [hl]
		inc			hl
		or			a, [hl]
		inc			hl
		or			a, [hl]
		ret			z						; R}hCIvV͎w肳ĂȂ

		; t@C̎w肪΃t@C[h
		ld			de, target_file_name
		ld			a, [de]
		or			a, a
		jp			z, skip_load
		call		load_mgs_file
skip_load:
		; eIvV̏
		ld			a, [option_p]
		or			a, a
		call		nz, play_music

		ld			a, [option_s]
		or			a, a
		call		nz, stop_music

		call		show_help

		xor			a, a
		inc			a
		ret
		endscope

; ==============================================================================
;	R}hCIvV𒲂ׂ
;	input)
;		[dma] .... Command line parameter
; ==============================================================================
		scope		check_options
check_options::
		ld			hl, dma + 1
		ld			b, 127				; max length of dma
skip_white_space:
		call		get_one
		ret			z
		cp			a, ' '
		jr			z, skip_white_space

		cp			a, '/'				; this is a option?
		jp			z, check_name

		; This is a file name
		ld			de, target_file_name
		ld			c, a
		ld			a, [de]
		or			a, a
		ld			a, c
		jr			nz, skip_2nd_file_name	; 2ڈȍ~̃t@C͖
copy_file_name:
		ld			[de], a
		inc			de
		call		get_one
		ret			z
		cp			a, ' '
		jr			nz, copy_file_name
		jp			skip_white_space
skip_2nd_file_name:
		call		get_one
		ret			z
		cp			a, ' '
		jr			nz, skip_2nd_file_name
		jp			skip_white_space

check_name:
		call		get_upper_one
		ret			z

		cp			a, 'H'
		jr			nz, not_help_option
		ld			a, 1
		ld			[option_h], a
		call		get_upper_one
		ret			z
not_help_option:

		cp			a, 'P'
		jr			nz, not_play_option
		ld			a, 1
		ld			[option_p], a
		call		get_upper_one
		ret			z
not_play_option:

		cp			a, 'S'
		jr			nz, not_stop_option
		ld			a, 1
		ld			[option_s], a
		call		get_upper_one
		ret			z
not_stop_option:

		cp			a, ' '
		jp			z, skip_white_space

		di
		ld			de, msg_invalid_option
		jp			g_error_exit
		endscope

		scope		get_one
get_one::
		ld			a, b
		or			a, a
		ret			z
		ld			a, [hl]
		inc			hl
		dec			b
		or			a, a
		ret
		endscope

		scope		get_upper_one
get_upper_one::
		call		get_one
		ret			z
		cp			a, 'a'
		ret			c
		cp			a, 'z' + 1
		ret			nc
		add			a, 'A' - 'a'
		ret
		endscope

; ==============================================================================
;	t@CǂݍŃ^Cg\XV
;	input)
;		de .... t@C̃AhX (ASCIIZ)
;	output)
;		Zf .... 0: , 1: s
; ==============================================================================
		scope		load_mgs_file_and_show_title
load_mgs_file_and_show_title::
		call		load_mgs_file
		ret			z

		; clear Music Title area
		ld			hl, (256 + 32) * 8
		ld			bc, 32 * 8
		xor			a, a
		ld			ix, FILVRM
		ld			iy, [exptbl - 1]
		call		CALSLT

		; draw Music Title
		call		change_mgsdrv_slot
		ld			hl, mgs_music_title
		ld			de, target_file_name
		ld			bc, target_file_name_end - target_file_name
		ldir									; page2 ɂȃf[^̃^Cg page0 ɃRs[

		ld			hl, (256 + 32) * 8
		ld			de, target_file_name
		call		draw_string					; page2 RAMƂėp

		; copy file name
		ld			hl, [file_name_address]
		ld			de, file_name_copy
		call		copy_file_name

		; clear file name area
		ld			hl, 251 * 8
		ld			bc, 4 * 8
		xor			a, a
		ld			ix, FILVRM
		ld			iy, [exptbl - 1]
		call		CALSLT

		; draw file name
		ld			hl, 251 * 8
		ld			de, file_name_copy
		call		draw_string

		call		change_mgsdrv_slot
		xor			a, a
		inc			a					; Zf = 0:
		ret
		endscope

; ==============================================================================
;	(HL)AɓĂl16i_v
; ==============================================================================
		scope		dec_to_hex
dec_to_hex::
		ld			b, a
		rrca
		rrca
		rrca
		rrca
		and			a, 0x0F
		add			a, '0'
		cp			a, '9' + 1
		jr			c, skip1
		add			a, 'A' - '0' - 10
skip1:
		ld			[hl], a
		inc			hl
		ld			a, b
		and			a, 0x0F
		add			a, '0'
		cp			a, '9' + 1
		jr			c, skip2
		add			a, 'A' - '0' - 10
skip2:
		ld			[hl], a
		inc			hl
		ret
		endscope

; ==============================================================================
;	AɓĂXbgԍ\
; ==============================================================================
		scope		put_slot_num
put_slot_num::
		ld			[save_slot], a
		inc			a
		jr			z, put_none
		dec			a
		and			a, 3
		add			a, '0'
		ld			e, a
		ld			c, D1F_CONOUT
		call		bdos
		ld			a, [save_slot]
		or			a, a
		ret			p

		ld			e, '-'
		ld			c, D1F_CONOUT
		call		bdos

		ld			a, [save_slot]
		rrca
		rrca
		and			a, 3
		add			a, '0'
		ld			e, a
		ld			c, D1F_CONOUT
		call		bdos
		ret
put_none:
		ld			de, msg_none
		call		puts
		ret

save_slot:
		db			0
		endscope

; ==============================================================================
;	DATA AREA
; ==============================================================================
keymap	macro		keycode, routine_name
		db			keycode
		dw			routine_name
		endm

keymap_table::
		keymap		0x08, goto_parent_dir		; [BS] Key
		keymap		0x0B, change_mode			; [HOME] Key
		keymap		0x1B, exit_main_loop		; [ESC] Key
		keymap		0x12, master_volume_down	; [INS] Key
		keymap		0x1C, right_select			; [] Key
		keymap		0x1D, left_select			; [] Key
		keymap		0x1E, up_select				; [] Key
		keymap		0x1F, down_select			; [] Key
		keymap		0x20, play_current_music	; [Space] Key
		keymap		'+', plus_select			; [+] Key
		keymap		'-', minus_select			; [-] Key
		keymap		'E', sort_by_filename		; [E] Key
		keymap		'F', start_fadeout			; [F] Key
		keymap		'N', sort_by_entry			; [N] Key
		keymap		'P', play_music				; [P] Key
		keymap		'S', stop_music				; [S] Key
		keymap		'T', sort_by_title			; [T] Key
		keymap		'X', loop_up				; [X] Key
		keymap		'Z', loop_down				; [Z] Key
		keymap		0x7F, master_volume_up		; [DEL] Key
		keymap		0xFF, 0x0000				; Terminator

joymap_table::
		keymap		1, up_select				; [] Key
		keymap		5, down_select				; [] Key
		keymap		3, right_select				; [] Key
		keymap		7, left_select				; [] Key
		keymap		0xFF, 0x0000				; Terminator

random_seed1::
		db			0xa3
random_seed2::
		db			0x5b
sort_mode::
		db			0			; \[g[h 0: Entry, 1: Title
play_mode::
		db			0			; 샂[h 0: Normal, 1: Random, 2: Repeat
playing_music_number::
		db			0			; Đ̋Ȃ̃t@Cԍ
play_state::
		db			0			; 0: ~, 1: ̋ȍĐ҂, 2: tF[hAEg, 3: Đ
fadeout_volume::
		db			0
loop_counter::
		db			2
joy_key_wait::
		db			0
joy_last_stick::
		db			255
joy_last_trigger::
		db			0
master_volume::
		db			0			; 0: Max, 15: Min
target_file_name::
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
target_file_name_end::
		db			0

option_h:
		db			0
option_p:
		db			0
option_s:
		db			0

msg_help::
		ds			">MGSP [options] [MGS file name]"
		db			0x0d, 0x0a
		ds			"/P ... Start playing and return to the command line."
		db			0x0d, 0x0a
		ds			"/S ... Stop playing and return to the command line."
		db			0x0d, 0x0a
		ds			"/H ... Show this help."
		db			0x0d, 0x0a, 0
msg_error_mmap_not_found::
		ds			"Memory mapper is not found."
		db			0x0d, 0x0a, 0
msg_error_mgsdrv_not_found::
		ds			"MGSDRV is not installed."
msg_ret::
		db			0x0d, 0x0a, 0
msg_invalid_option:
		ds			"Invalid option."
		db			0x0d, 0x0a, 0
msg_segment_error:
		ds			"Segment error."
		db			0x0d, 0x0a, 0
msg_cannot_read_kfont::
		ds			"Cannot read KFONT.BIN."
		db			0x0d, 0x0a, 0
msg_detect::
		ds			"Detect MGSDRV "
		db			0
msg_opll_slot_num::
		ds			"  OPLL SLOT #"
		db			0
msg_scc_slot_num::
		ds			"  SCC  SLOT #"
		db			0
msg_none::
		ds			"none"
		db			0
msg_1byte_hex::
		ds			"00"
		db			0
msg_cannot_open_file::
		ds			"Cannot open the file."
		db			0x0d, 0x0a, 0
msg_invalid_data::
		ds			"Invalid music data."
		db			0x0d, 0x0a, 0
msg_not_enough_memory::
		ds			"Not enough memory."
		db			0x0d, 0x0a, 0

		include	"mgsdrvctl.asm";
		include	"file_list.asm"
		include	"string.asm"
		include	"stdio.asm"
		include	"memmapper.asm"
		include	"kanji.asm"
		include	"graphic.asm"
end_of_program::
